/**********************************************************************
*  2007 Microchip Technology Inc.
*
* FileName:        clockSwitch.s
* Dependencies:    Header (.h) files if applicable, see below
* Processor:       PIC24Fxxxx
* Compiler:        MPLAB C30 v3.00 or higher
*
* SOFTWARE LICENSE AGREEMENT:
* Microchip Technology Incorporated ("Microchip") retains all 
* ownership and intellectual property rights in the code accompanying
* this message and in all derivatives hereto.  You may use this code,
* and any derivatives created by any person or entity by or on your 
* behalf, exclusively with Microchip's proprietary products.  Your 
* acceptance and/or use of this code constitutes agreement to the 
* terms and conditions of this notice.
*
* CODE ACCOMPANYING THIS MESSAGE IS SUPPLIED BY MICROCHIP "AS IS". NO 
* WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT 
* NOT LIMITED TO, IMPLIED WARRANTIES OF NON-INFRINGEMENT, 
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS 
* CODE, ITS INTERACTION WITH MICROCHIP'S PRODUCTS, COMBINATION WITH 
* ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
*
* YOU ACKNOWLEDGE AND AGREE THAT, IN NO EVENT, SHALL MICROCHIP BE 
* LIABLE, WHETHER IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE OR
* BREACH OF STATUTORY DUTY), STRICT LIABILITY, INDEMNITY, 
* CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
* EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, FOR COST OR 
* EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE CODE, HOWSOEVER 
* CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE
* DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT ALLOWABLE BY LAW, 
* MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS
* CODE, SHALL NOT EXCEED THE PRICE YOU PAID DIRECTLY TO MICROCHIP 
* SPECIFICALLY TO HAVE THIS CODE DEVELOPED.
*
* You agree that you are solely responsible for testing the code and 
* determining its suitability.  Microchip has no obligation to modify,
* test, certify, or support the code.
*
* REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author        Date      	Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Albert Z.		01/23/08	First release of source file
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*
* ADDITIONAL NOTES:
*
*
**********************************************************************/


.include "p24fxxxx.inc"


	.global 	_clockSwitch
	.global 	_testClockSwitch

	.section .text

/*********************************************************************
  CLOCK SWITCH
*********************************************************************/
_clockSwitch:
		;Place the new oscillator selection in W0
		mov		w0,w1
		
		;; if NOSC_SOSC, OSCCONL = 0x3, else OSCCONL = 0x1.
		mov		#0, w2
		mov		#4, w4
		cpsne	w0, w4
		mov.b	#3, w2
		ior		#1, w2
		mov.b	w2, w4
		;;
		
		mov.b 	OSCCONH,WREG
		and		#0xF8,w0
		ior		w0,w1,w0	

		;OSCCONH(High byte) Unlock Sequence
		mov 	#OSCCONH, w1
		mov 	#0x78, w2
		mov 	#0x9a, w3
		mov.b 	w2, [w1]
		mov.b 	w3, [w1]
		
		;Set New Oscillator Selection
		mov.b 	WREG,OSCCONH

		;OSCCONL(Low byte) Unlock Sequence
		mov 	#OSCCONL, w1
		mov 	#0x46, w2
		mov 	#0x57, w3
		mov.b 	w2, [w1]
		mov.b 	w3, [w1]

		;Start Oscillator Switch Operation
		mov.b	w4, [w1]	;;

wait:     
		btsc    OSCCONL, #OSWEN
        bra     wait		

       	return

.end

